SystemOrganization addCategory: #'SqueakElib-Compiler'!
SystemOrganization addCategory: #'SqueakElib-Compiler-Nodes'!

!ContextPart methodsFor: '*squeakelib-compiler' stamp: 'rww 10/30/2007 08:45'!
isBlockTest

	| temp |
	temp := self pop.
	self push: ((temp isKindOf: BlockContext) or: [temp isKindOf: BlockClosure]).
! !

!ContextPart methodsFor: '*squeakelib-compiler' stamp: 'rww 10/30/2007 08:45'!
isBooleanTest

	| temp |
	temp := self pop.
	self push: (temp == true or: [temp == false]).
! !

!ContextPart methodsFor: '*squeakelib-compiler' stamp: 'rww 10/30/2007 08:46'!
isIntegerTest

	| temp |
	temp := self pop.
	self push: (temp isKindOf: SmallInteger).
! !

!ContextPart methodsFor: '*squeakelib-compiler' stamp: 'rww 10/30/2007 08:46'!
notEventualTest

	| temp |
	temp := self pop.
	self push: true.
! !

!InstructionPrinter methodsFor: '*squeakelib-compiler' stamp: 'rww 10/19/2007 20:13'!
isBlockTest
	"Print the Is Boolean Test bytecode."

	self print: 'isBlockTest'.
! !

!InstructionPrinter methodsFor: '*squeakelib-compiler' stamp: 'rww 10/19/2007 19:43'!
isBooleanTest
	"Print the Is Boolean Test bytecode."

	self print: 'isBooleanTest'.
! !

!InstructionPrinter methodsFor: '*squeakelib-compiler' stamp: 'rww 10/19/2007 20:13'!
isIntegerTest
	"Print the Is Boolean Test bytecode."

	self print: 'isIntegerTest'.
! !

!InstructionPrinter methodsFor: '*squeakelib-compiler' stamp: 'rww 10/20/2007 11:31'!
notEventualTest
	"Print the Not Eventual Test bytecode."

	self print: 'notEventualTest'.
! !

!CompiledMethod class methodsFor: '*squeakelib-compiler' stamp: 'rww 10/23/2007 20:55'!
initialize    "CompiledMethod initialize"
	"Initialize class variables specifying the size of the temporary frame
	needed to run instances of me."

	SmallFrame _ 16.	"Context range for temps+stack"
	LargeFrame _ 80.

	self classPool at: #BlockNodeCache ifAbsentPut: [nil->nil].! !

!Compiler class methodsFor: '*squeakelib-compiler' stamp: 'rww 10/19/2007 18:23'!
compile: src

	| methodNode |
	methodNode := self new
		compileNoPattern: src
		in: Object
		context: nil
		notifying: nil
		ifFail: [].
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: #(0 0 0 0).
! !

!Compiler class methodsFor: '*squeakelib-compiler' stamp: 'rww 10/23/2007 15:43'!
compile: selector in: targetClass

	| methodNode |
	methodNode := self new
		compile: (targetClass sourceCodeAt: selector)
		in: targetClass
		classified: nil
		notifying: nil
		ifFail: [].
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: #(0 0 0 0).
! !

!Compiler class methodsFor: '*squeakelib-compiler' stamp: 'rww 10/28/2007 19:04'!
parserClass
	"Return a parser class to use for parsing method headers."

	^ Parser! !

Compiler subclass: #ConditionalTransformCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!ConditionalTransformCompiler class methodsFor: 'testing' stamp: 'rww 10/21/2007 18:07'!
compile: selector in: targetClass
	"ConditionalTransformCompiler compile: #emitForValue:on: in: TypeTestNode"
	"ConditionalTransformCompiler compile: #messagePart:repeat: in: Parser"

	| methodNode |
	methodNode := self new
		compile: (targetClass sourceCodeAt: selector)
		in: targetClass
		classified: nil
		notifying: nil
		ifFail: [].
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: #(0 0 0 0).
! !

!ConditionalTransformCompiler class methodsFor: 'accessing' stamp: 'rww 10/19/2007 18:26'!
parserClass

	^ ConditionalTransformParser! !

Compiler subclass: #MacroTransformCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!MacroTransformCompiler class methodsFor: 'as yet unclassified' stamp: 'rww 10/20/2007 07:38'!
parserClass

	^ MacroTransformParser! !

Compiler subclass: #NoTransformCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!NoTransformCompiler class methodsFor: 'accessing' stamp: 'rww 10/19/2007 17:55'!
parserClass

	^ NoTransformParser! !

MessageNode subclass: #ConditionalTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: 'ConditionalTransformMessageNodeClasses'
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

ConditionalTransformMessageNode subclass: #CaseTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!CaseTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/20/2007 13:37'!
nodeClass

	^ NotEventualTestNode! !

!CaseTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/24/2007 11:58'!
receiver: rcvr selector: aSelector arguments: args precedence: p from: encoder 
	"Compile."

"	| probe macroTempName macroTempNode |
	self noteSpecialSelector: aSelector.
	probe := 0.
	[macroTempName := 'macroTemp', probe asString.
	encoder tempNames includes: macroTempName]
		whileTrue: [probe := probe + 1].
	macroTempNode := encoder bindTemp: macroTempName.
	^ super 
		receiver: (self nodeClass new 
			expression: (AssignmentNode new
					variable: macroTempNode
					value: rcvr))
		selector: #ifTrue:ifFalse:
		arguments: (Array 
			with: (BlockNode withJust: (MacroTransformMessageNode new 
				receiver: macroTempNode 
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder))
			with: (BlockNode withJust: (NoTransformMessageNode new 
				receiver: macroTempNode 
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder)))
		precedence: p 
		from: encoder.
"

	^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder! !

!ConditionalTransformMessageNode class methodsFor: 'as yet unclassified' stamp: 'rww 10/20/2007 13:38'!
initialize		"ConditionalTransformMessageNode initialize"

	super initialize.
	ConditionalTransformMessageNodeClasses := Dictionary new
		at: #ifTrue: put: IfTrueIfFalseTransformMessageNode;
		at: #ifFalse: put: IfTrueIfFalseTransformMessageNode;
		at: #ifTrue:ifFalse: put: IfTrueIfFalseTransformMessageNode;
		at: #ifFalse:ifTrue: put: IfTrueIfFalseTransformMessageNode;
		at: #and: put: IfTrueIfFalseTransformMessageNode;
		at: #or: put: IfTrueIfFalseTransformMessageNode;
		at: #whileFalse: put: WhileTransformMessageNode;
		at: #whileTrue: put: WhileTransformMessageNode;
		at: #whileFalse put: WhileTransformMessageNode;
		at: #whileTrue put: WhileTransformMessageNode;
		at: #to:do: put: ToDoTransformMessageNode;
		at: #to:by:do: put: ToDoTransformMessageNode;
		at: #caseOf: put: CaseTransformMessageNode;
		at: #caseOf:otherwise: put: CaseTransformMessageNode;
		at: #ifNil: put: IfNilIfNotNilTransformMessageNode;
		at: #ifNotNil: put: IfNilIfNotNilTransformMessageNode;
		at: #ifNil:ifNotNil: put: IfNilIfNotNilTransformMessageNode;
		at: #ifNotNil:ifNil: put: IfNilIfNotNilTransformMessageNode;
		yourself.
! !

!ConditionalTransformMessageNode class methodsFor: 'instance creation' stamp: 'rww 10/20/2007 11:12'!
receiver: rcvr selector: selName arguments: args precedence: p from: encoder sourceRange: range 
	"Compile."

	| messageNodeClass |
	messageNodeClass := ConditionalTransformMessageNodeClasses
		at: selName
		ifAbsent: [nil].
	messageNodeClass isNil 
		ifTrue: [^ MessageNode new
			receiver: rcvr
			selector: selName
			arguments: args
			precedence: p
			from: encoder
			sourceRange: range].
	^ messageNodeClass new
		receiver: rcvr
		selector: selName
		arguments: args
		precedence: p
		from: encoder
		sourceRange: range.
! !

ConditionalTransformMessageNode subclass: #IfNilIfNotNilTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!IfNilIfNotNilTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/20/2007 13:37'!
nodeClass

	^ NotEventualTestNode! !

!IfNilIfNotNilTransformMessageNode methodsFor: 'as yet unclassified' stamp: 'rww 11/5/2007 07:00'!
receiver: rcvr selector: aSelector arguments: args precedence: p from: encoder 
	"Compile."

"	| probe macroTempName macroTempNode |
	self noteSpecialSelector: aSelector.
	probe := 0.
	[macroTempName := 'macroTemp', probe asString.
	encoder tempNames includes: macroTempName]
		whileTrue: [probe := probe + 1].
	macroTempNode := encoder bindTemp: macroTempName.
	^ super 
		receiver: (self nodeClass new 
			expression: (AssignmentNode new
					variable: macroTempNode
					value: rcvr))
		selector: #ifTrue:ifFalse:
		arguments: (Array 
			with: (BlockNode withJust: (MacroTransformMessageNode new 
				receiver: macroTempNode
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder))
			with: (BlockNode withJust: (NoTransformMessageNode new 
				receiver: macroTempNode
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder)))
		precedence: p 
		from: encoder.
"

	^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder
! !

ConditionalTransformMessageNode subclass: #IfTrueIfFalseTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!IfTrueIfFalseTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/20/2007 13:36'!
nodeClass

	^ IsBooleanTestNode! !

!IfTrueIfFalseTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 11/6/2007 08:08'!
receiver: rcvr selector: aSelector arguments: args precedence: p from: encoder 
	"Compile."

	| probe macroTempName macroTempNode |
	self noteSpecialSelector: aSelector.
	probe := 0.
	[macroTempName := 'macroTemp', probe asString.
	encoder tempNames includes: macroTempName]
		whileTrue: [probe := probe + 1].
	macroTempNode := encoder bindTemp: macroTempName.
	^ super 
		receiver: (self nodeClass new 
			expression: (AssignmentNode new
					variable: macroTempNode
					value: rcvr))
		selector: #ifTrue:ifFalse:
		arguments: (Array 
			with: (BlockNode withJust: (MacroTransformMessageNode new 
				receiver: macroTempNode
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder))
			with: (BlockNode withJust: (NoTransformMessageNode new 
				receiver: macroTempNode
				selector: aSelector 
				arguments: args 
				precedence: p 
				from: encoder)))
		precedence: p 
		from: encoder.


"	^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder
"

"	^ NoTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder
"! !

ConditionalTransformMessageNode subclass: #ToDoTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!ToDoTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/20/2007 13:36'!
nodeClass

	^ IsIntegerTestNode! !

!ToDoTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/24/2007 11:58'!
receiver: rcvr selector: aSelector arguments: args precedence: p from: encoder 
	"Compile."

	^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder! !

ConditionalTransformMessageNode subclass: #WhileTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!WhileTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/20/2007 13:36'!
nodeClass

	^ IsBlockTestNode! !

!WhileTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/23/2007 11:29'!
noteSpecialSelector: selectorSymbol

	| stack parser |
	super noteSpecialSelector: selectorSymbol.
	stack := thisContext.
	[(parser := stack client) isKindOf: Parser]
		whileFalse: [stack := stack sender].
	((parser isMemberOf: Parser)
		or: [selectorSymbol == parser forMethodSelector])
			ifFalse: [special := 0]
! !

!WhileTransformMessageNode methodsFor: 'initialize-release' stamp: 'rww 10/24/2007 02:13'!
receiver: rcvr selector: aSelector arguments: args precedence: p from: encoder 
	"Compile."

"	self noteSpecialSelector: aSelector.
	special > 0
		ifTrue: [^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder]
		ifFalse: [^ NoTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder]
"

	^ MacroTransformMessageNode new 
			receiver: rcvr 
			selector: aSelector 
			arguments: args 
			precedence: p 
			from: encoder! !

MessageNode subclass: #MacroTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!MessageNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 00:08'!
sizeToDo: encoder value: forValue 
	" var _ rcvr. L1: [var <= arg1] Bfp(L2) [block body. var _ var + inc] Jmp(L1) L2: "
	| loopSize initStmt test block incStmt blockSize blockVar initSize limitInit jumpSize |
	block _ arguments at: 3.
	blockVar _ block firstArgument.
	initStmt _ arguments at: 4.
	test _ arguments at: 5.
	incStmt _ arguments at: 6.
	limitInit _ arguments at: 7.
	initSize _ initStmt sizeForEffect: encoder.
	limitInit == nil
		ifFalse: [initSize _ initSize + (limitInit sizeForEffect: encoder)].
	blockSize _ (block sizeForEvaluatedEffect: encoder)
			+ (incStmt sizeForEffect: encoder) + 2.  "+2 for Jmp backward"
	jumpSize := self sizeJump: ((test sizeForValue: encoder)
			+ (self sizeBranchOn: false dist: blockSize)
			+ (block sizeForEvaluatedEffect: encoder)
			+ (incStmt sizeForEffect: encoder)).
	blockSize := blockSize + jumpSize - 2.
	loopSize _ (test sizeForValue: encoder)
			+ (self sizeBranchOn: false dist: blockSize)
			+ blockSize.
	sizes _ Array with: blockSize with: loopSize.
	^ initSize + loopSize
			+ (forValue ifTrue: [1] ifFalse: [0])    " +1 for value (push nil) "! !

!MessageNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 02:21'!
sizeWhile: encoder value: forValue 
	"L1: ... Bfp(L2) ... Jmp(L1) L2: nil (nil for value only);
	justStmt, wholeLoop, justJump."
	| cond stmt stmtSize loopSize branchSize jumpSize |
	cond _ receiver.
	stmt _ arguments at: 1.
	stmtSize _ (stmt sizeForEvaluatedEffect: encoder) + 2.
	branchSize _ self sizeBranchOn: (selector key == #whileFalse:)  "Btp for whileFalse"
					dist: stmtSize.
	loopSize _ (cond sizeForEvaluatedValue: encoder)
			+ branchSize + stmtSize.
	jumpSize := self sizeJump: 0 - loopSize.
	stmtSize := stmtSize + jumpSize - 2.
	branchSize _ self sizeBranchOn: (selector key == #whileFalse:)  "Btp for whileFalse"
					dist: stmtSize.
	loopSize _ (cond sizeForEvaluatedValue: encoder)
			+ branchSize + stmtSize.
	sizes _ Array with: stmtSize with: loopSize.
	^ loopSize    " +1 for value (push nil) "
		+ (forValue ifTrue: [1] ifFalse: [0])! !

MessageNode subclass: #NoTransformMessageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!NoTransformMessageNode methodsFor: 'as yet unclassified' stamp: 'rww 10/20/2007 16:56'!
noteSpecialSelector: selectorSymbol

	special _ 0.! !

Parser subclass: #ConditionalTransformParser
	instanceVariableNames: 'forMethodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!ConditionalTransformParser methodsFor: 'as yet unclassified' stamp: 'rww 10/19/2007 18:26'!
forMethodSelector
	^forMethodSelector! !

!ConditionalTransformParser methodsFor: 'expression types' stamp: 'rww 10/20/2007 11:13'!
messagePart: level repeat: repeat

	| start receiver selector args precedence words keywordStart |
	[receiver _ parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start _ self startOfNextToken.
			selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			words _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart _ self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(Symbol hasInterned: selector contents ifTrue: [ :sym | selector _ sym])
				ifFalse: [ selector _ self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence _ 3]
		ifFalse: [((hereType == #binary or: [hereType == #verticalBar])
				and: [level >= 2])
				ifTrue: 
					[start _ self startOfNextToken.
					selector _ self advance asOctetString asSymbol.
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args _ Array with: parseNode.
					precedence _ 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start _ self startOfNextToken.
							selector _ self advance.
							args _ #().
							words _ OrderedCollection with: (start  + requestorOffset to: self endOfLastToken + requestorOffset).
							(Symbol hasInterned: selector ifTrue: [ :sym | selector _ sym])
								ifFalse: [ selector _ self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence _ 1]
						ifFalse: [^args notNil]]].
	parseNode _ ConditionalTransformMessageNode
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken).
	repeat]
		whileTrue: [].
	^true
! !

!ConditionalTransformParser methodsFor: 'expression types' stamp: 'rww 10/19/2007 18:26'!
temporariesIn: messageSelector
	"store the selector whose method we are compiling"
	forMethodSelector _ messageSelector.
	^super temporariesIn: messageSelector! !

Parser subclass: #MacroTransformParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!MacroTransformParser methodsFor: 'expression types' stamp: 'rww 10/20/2007 07:38'!
messagePart: level repeat: repeat

	| start receiver selector args precedence words keywordStart |
	[receiver _ parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start _ self startOfNextToken.
			selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			words _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart _ self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(Symbol hasInterned: selector contents ifTrue: [ :sym | selector _ sym])
				ifFalse: [ selector _ self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence _ 3]
		ifFalse: [((hereType == #binary or: [hereType == #verticalBar])
				and: [level >= 2])
				ifTrue: 
					[start _ self startOfNextToken.
					selector _ self advance asOctetString asSymbol.
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args _ Array with: parseNode.
					precedence _ 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start _ self startOfNextToken.
							selector _ self advance.
							args _ #().
							words _ OrderedCollection with: (start  + requestorOffset to: self endOfLastToken + requestorOffset).
							(Symbol hasInterned: selector ifTrue: [ :sym | selector _ sym])
								ifFalse: [ selector _ self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence _ 1]
						ifFalse: [^args notNil]]].
	parseNode _ MacroTransformMessageNode new
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken).
	repeat]
		whileTrue: [].
	^true
! !

Parser subclass: #NoTransformParser
	instanceVariableNames: 'forMethodSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!NoTransformParser commentStamp: '<historical>' prior: 0!
I do not macro transform selectors except recursive ones (like, for example, #whileFalse:).!

!NoTransformParser methodsFor: 'public access' stamp: 'kwl 10/16/2007 23:37'!
forMethodSelector
	^forMethodSelector! !

!NoTransformParser methodsFor: 'expression types' stamp: 'rww 10/19/2007 17:53'!
messagePart: level repeat: repeat

	| start receiver selector args precedence words keywordStart |
	[receiver _ parseNode.
	(hereType == #keyword and: [level >= 3])
		ifTrue: 
			[start _ self startOfNextToken.
			selector _ WriteStream on: (String new: 32).
			args _ OrderedCollection new.
			words _ OrderedCollection new.
			[hereType == #keyword]
				whileTrue: 
					[keywordStart _ self startOfNextToken + requestorOffset.
					selector nextPutAll: self advance.
					words addLast: (keywordStart to: self endOfLastToken + requestorOffset).
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 2 repeat: true.
					args addLast: parseNode].
			(Symbol hasInterned: selector contents ifTrue: [ :sym | selector _ sym])
				ifFalse: [ selector _ self correctSelector: selector contents
										wordIntervals: words
										exprInterval: (start to: self endOfLastToken)
										ifAbort: [ ^ self fail ] ].
			precedence _ 3]
		ifFalse: [((hereType == #binary or: [hereType == #verticalBar])
				and: [level >= 2])
				ifTrue: 
					[start _ self startOfNextToken.
					selector _ self advance asOctetString asSymbol.
					self primaryExpression ifFalse: [^self expected: 'Argument'].
					self messagePart: 1 repeat: true.
					args _ Array with: parseNode.
					precedence _ 2]
				ifFalse: [hereType == #word
						ifTrue: 
							[start _ self startOfNextToken.
							selector _ self advance.
							args _ #().
							words _ OrderedCollection with: (start  + requestorOffset to: self endOfLastToken + requestorOffset).
							(Symbol hasInterned: selector ifTrue: [ :sym | selector _ sym])
								ifFalse: [ selector _ self correctSelector: selector
													wordIntervals: words
													exprInterval: (start to: self endOfLastToken)
													ifAbort: [ ^ self fail ] ].
							precedence _ 1]
						ifFalse: [^args notNil]]].
	parseNode _ NoTransformMessageNode new
				receiver: receiver
				selector: selector
				arguments: args
				precedence: precedence
				from: encoder
				sourceRange: (start to: self endOfLastToken).
	repeat]
		whileTrue: [].
	^true
! !

!NoTransformParser methodsFor: 'expression types' stamp: 'kwl 10/16/2007 23:03'!
temporariesIn: messageSelector
	"store the selector whose method we are compiling"
	forMethodSelector _ messageSelector.
	^super temporariesIn: messageSelector! !

Object subclass: #ConditionalTransformCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!ConditionalTransformCompilerTest methodsFor: 'as yet unclassified' stamp: 'rww 10/23/2007 11:17'!
test: test

	^ test ifTrue: [4+2] ! !

!ConditionalTransformCompilerTest methodsFor: 'as yet unclassified' stamp: 'rww 10/23/2007 16:49'!
testStackDepth

	| subst otherVectors jM1T2 iM1T2 myVectors otherPoints myPoints otherAngles myAngles jM1 iM1 base insertBase |
	otherVectors := 0. 
	jM1T2  := 0.
	iM1T2  := 0.
	myVectors  := 0.
	otherPoints  := 0.
	myPoints  := 0.
	otherAngles  := 0.
	myAngles  := 0.
	jM1  := 0.
	iM1  := 0.
	insertBase  := 0.

	1
		to: 10
		do: [:i |
			1
				to: 10
				do: [:j |
					false
						ifFalse: [subst := (self
										cSquaredDistanceFrom: (otherVectors + jM1T2)
										to: (myVectors + iM1T2))
										+ (self
												cSquaredDistanceFrom: (otherPoints + jM1T2)
												to: (myPoints + iM1T2)) * (16
											+ (self
													cSubstAngleFactorFrom: (otherAngles at: jM1)
													to: (myAngles at: iM1))) bitShift: -11].
					(0 <= 1
							and: [0 <= 2])
						ifFalse: [9 <= 11
								ifFalse: [base := insertBase]]
		]].
! !

Decompiler subclass: #ConditionalTransformDecompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!ConditionalTransformDecompiler class methodsFor: 'testing' stamp: 'rww 10/21/2007 17:27'!
compileThenDecompile: selector in: targetClass
	"ConditionalTransformDecompiler compileThenDecompile: #emitForValue:on: in: TypeTestNode"
	"ConditionalTransformDecompiler compileThenDecompile: #messagePart:repeat: in: Parser"

	| methodNode |
	methodNode := ConditionalTransformCompiler new
		compile: (targetClass sourceCodeAt: selector)
		in: targetClass
		classified: nil
		notifying: nil
		ifFail: [].
	^ ConditionalTransformDecompiler new
		decompile: selector
		in: targetClass
		method: (CompiledMethodWithNode 
			generateMethodFromNode: methodNode 
			trailer: #(0 0 0 0)) method.
! !

!ConditionalTransformDecompiler methodsFor: 'public access' stamp: 'rww 10/21/2007 16:01'!
decompile: aSelector in: aClass method: aMethod
	"Answer a MethodNode that is the root of the parse tree for the 
	argument, aMethod, which is the CompiledMethod associated with the 
	message, aSelector. Variables are determined with respect to the 
	argument, aClass."

	^self
		decompile: aSelector
		in: aClass
		method: aMethod
		using: ConditionalTransformDecompilerConstructor new! !

!Decompiler methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 13:04'!
isBlockTest! !

!Decompiler methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 13:04'!
isBooleanTest! !

!Decompiler methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 13:04'!
isIntegerTest! !

!Decompiler methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 13:04'!
notEventualTest! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 20:25'!
emitExtraLong: dist code: longCode on: aStream 
	"Force a full two-byte jump."
	| code distance |
	code := longCode.
	distance := dist.

	(distance < -32767 or: [distance > 32768])
		ifTrue: [self error: 'A block compiles more than 32K bytes of code'].

	code = JmpLong 
		ifTrue: [
			distance := distance + 32768.
			code := 128].
	code = BtpLong 
		ifTrue: [code := 129].
	code = (Bfp + (JmpLong - Jmp))
		ifTrue: [code := 130].

	aStream nextPut: 126.
	aStream nextPut: code.
	aStream nextPut: distance // 256.
	aStream nextPut: distance \\ 256.
! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/20/2007 23:28'!
emitLong: dist code: longCode on: aStream 
	"Force a two-byte jump."
	| code distance |
	code _ longCode.
	distance _ dist.
	distance < 0
		ifTrue: 
			[distance _ distance + 1024.
			code _ code - 4]
		ifFalse: 
			[distance > 1023 ifTrue: [distance _ -1]].
	distance < 0
		ifTrue: 
			[self emitExtraLong: dist code: longCode on: aStream]
		ifFalse: 
			[aStream nextPut: distance // 256 + code.
			aStream nextPut: distance \\ 256]! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 11:14'!
sizeBranchOn: condition dist: dist
	dist = 0 ifTrue: [^1].
	^ condition
		ifTrue: [self sizeLongOrExtraLong: dist]
		ifFalse: [self sizeShortOrLongOrExtraLong: dist]! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 11:14'!
sizeJump: dist

	dist = 0 ifTrue: [^0].
	^self sizeShortOrLongOrExtraLong: dist! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 11:14'!
sizeLongJump: dist

	dist = 0 ifTrue: [^0].
	^self sizeLongOrExtraLong: dist! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 03:26'!
sizeLongOrExtraLong: dist

	(dist between: -1024 and: 1023)
		ifTrue: [^2].
	^ 4! !

!ParseNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 03:26'!
sizeShortOrLongOrExtraLong: dist

	(1 <= dist and: [dist <= JmpLimit])
		ifTrue: [^1].
	(dist between: -1024 and: 1023)
		ifTrue: [^2].
	^ 4! !

ParseNode subclass: #TypeTestNode
	instanceVariableNames: 'expression dupReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

TypeTestNode subclass: #IsBlockTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!IsBlockTestNode methodsFor: 'as yet unclassified' stamp: 'rww 10/19/2007 20:12'!
subcode

	^ 3! !

!IsBlockTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:08'!
symbolicName

	^ 'isBlockTest'! !

TypeTestNode subclass: #IsBooleanTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!IsBooleanTestNode methodsFor: 'as yet unclassified' stamp: 'rww 10/19/2007 20:11'!
subcode

	^ 1! !

!IsBooleanTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:09'!
symbolicName

	^ 'isBooleanTest'! !

TypeTestNode subclass: #IsIntegerTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!IsIntegerTestNode methodsFor: 'as yet unclassified' stamp: 'rww 10/19/2007 20:12'!
subcode

	^ 2! !

!IsIntegerTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:09'!
symbolicName

	^ 'isIntegerTest'! !

TypeTestNode subclass: #NotEventualTestNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler-Nodes'!

!NotEventualTestNode methodsFor: 'as yet unclassified' stamp: 'rww 10/20/2007 11:30'!
subcode

	^ 4! !

!NotEventualTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:09'!
symbolicName

	^ 'notEventualTest'! !

!TypeTestNode methodsFor: 'as yet unclassified' stamp: 'rww 10/19/2007 20:11'!
code

	^ 126! !

!TypeTestNode methodsFor: 'accessing' stamp: 'rww 10/20/2007 11:57'!
dupReceiver
	"Answer the value of dupReceiver"

	dupReceiver ifNil: [dupReceiver := false].
	^ dupReceiver! !

!TypeTestNode methodsFor: 'accessing' stamp: 'rww 10/20/2007 11:56'!
dupReceiver: anObject
	"Set the value of dupReceiver"

	dupReceiver := anObject! !

!TypeTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 11:57'!
emitForValue: stack on: aStream

	self expression emitForValue: stack on: aStream.
	self dupReceiver ifTrue: [
		aStream nextPut: Dup.
		stack push: 1].
	aStream nextPut: self code; nextPut: self subcode.
! !

!TypeTestNode methodsFor: 'accessing' stamp: 'rww 10/19/2007 18:53'!
expression
	"Answer the value of expression"

	^ expression! !

!TypeTestNode methodsFor: 'accessing' stamp: 'rww 10/19/2007 18:53'!
expression: anObject
	"Set the value of expression"

	expression := anObject! !

!TypeTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:08'!
printOn: aStream indent: level

	aStream nextPut: $(.
	self expression printOn: aStream indent: level.
	aStream nextPut: $).
	self dupReceiver ifTrue: [
		aStream nextPutAll: ' dup'].
	aStream nextPut: $ .
	aStream nextPutAll: self symbolicName.
! !

!TypeTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 11:58'!
sizeForValue: encoder

	^ (self expression sizeForValue: encoder) + 2 + (self dupReceiver ifTrue: [1] ifFalse: [0])! !

!TypeTestNode methodsFor: 'code generation' stamp: 'rww 10/20/2007 16:08'!
symbolicName

	self subclassResponsibility.! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 17:45'!
interpretJump

	| byte byte2 |
	byte _ self nextByte.
	(byte between: 144 and: 151) ifTrue:
		[pc _ pc + 1. ^byte - 143].
	(byte between: 160 and: 167) ifTrue:
		[pc _ pc + 2. ^(byte - 164) * 256 + (self method at: pc - 1)].
	(byte = 126) ifTrue:
		[byte2 := self followingByte.
		byte2 = 128 ifTrue:
			[pc _ pc + 4. ^((self method at: pc - 2) - 128) * 256 + (self method at: pc - 1)]].
	^nil! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 19:19'!
interpretNextInstructionFor: client 
	"Send to the argument, client, a message that specifies the type of the 
	next instruction."

	| byte type offset method base |
	method := self method.  
	byte := method at: pc.
	type := byte // 16.  
	offset := byte \\ 16.  
	pc := pc+1.
	"We do an inline binary search on each of the possible 16 values of type:
	The old, cleaner but slowe code is retained as a comment below"
	type < 8
	ifTrue: [type < 4
				ifTrue: [type < 2
						ifTrue: [type < 1
								ifTrue: ["type = 0"
									^ client pushReceiverVariable: offset]
								ifFalse: ["type = 1"
									^ client pushTemporaryVariable: offset]]
						ifFalse: [type < 3
								ifTrue: ["type = 2"
									^ client
										pushConstant: (method literalAt: offset + 1)]
								ifFalse: ["type = 3"
									^ client
										pushConstant: (method literalAt: offset + 17)]]]
				ifFalse: [type < 6
						ifTrue: [type < 5
								ifTrue: ["type = 4"
									^ client
										pushLiteralVariable: (method literalAt: offset + 1)]
								ifFalse: ["type = 5"
									^ client
										pushLiteralVariable: (method literalAt: offset + 17)]]
						ifFalse: [type < 7
								ifTrue: ["type = 6"
									offset < 8
										ifTrue: [^ client popIntoReceiverVariable: offset]
										ifFalse: [^ client popIntoTemporaryVariable: offset - 8]]
								ifFalse: ["type = 7"
									offset = 0
										ifTrue: [^ client pushReceiver].
									offset < 8
										ifTrue: [^ client
												pushConstant: (SpecialConstants at: offset)].
									offset = 8
										ifTrue: [^ client methodReturnReceiver].
									offset < 12
										ifTrue: [^ client
												methodReturnConstant: (SpecialConstants at: offset - 8)].
									offset = 12
										ifTrue: [^ client methodReturnTop].
									offset = 13
										ifTrue: [^ client blockReturnTop].
									offset = 14
										ifTrue: [
											byte := method at: pc.
											pc := pc + 1.
											byte = 1 
												ifTrue: [^ client isBooleanTest].
											byte = 2 
												ifTrue: [^ client isIntegerTest].
											byte = 3
												ifTrue: [^ client isBlockTest].
											byte = 4
												ifTrue: [^ client notEventualTest].
											byte = 128
												ifTrue: [
													base := method at: pc.
													pc := pc + 1.
													byte := method at: pc.
													pc := pc + 1.
													^ client jump: base - 128 * 256 + byte].
											byte = 129
												ifTrue: [
													base := method at: pc.
													pc := pc + 1.
													byte := method at: pc.
													pc := pc + 1.
													^ client jump: (base bitAnd: 127) * 256 + byte if: true].
											byte = 130
												ifTrue: [
													base := method at: pc.
													pc := pc + 1.
													byte := method at: pc.
													pc := pc + 1.
													^ client jump: (base bitAnd: 127) * 256 + byte if: false].
											^ self error: 'badBytecode'].
									offset > 14
										ifTrue: [^ self error: 'unusedBytecode']]]]]
		ifFalse: [type < 12
				ifTrue: [type < 10
						ifTrue: [type < 9
								ifTrue: ["type = 8"
									^ self
										interpretExtension: offset
										in: method
										for: client]
								ifFalse: ["type = 9 (short jumps)"
									offset < 8
										ifTrue: [^ client jump: offset + 1].
									^ client jump: offset - 8 + 1 if: false]]
						ifFalse: [type < 11
								ifTrue: ["type = 10 (long jumps)"
									byte := method at: pc.
									pc := pc + 1.
									offset < 8
										ifTrue: [^ client jump: offset - 4 * 256 + byte].
									^ client jump: (offset bitAnd: 3)
											* 256 + byte if: offset < 12]
								ifFalse: ["type = 11"
									^ client
										send: (Smalltalk specialSelectorAt: offset + 1)
										super: false
										numArgs: (Smalltalk specialNargsAt: offset + 1)]]]
				ifFalse: [type = 12
						ifTrue: [^ client
								send: (Smalltalk specialSelectorAt: offset + 17)
								super: false
								numArgs: (Smalltalk specialNargsAt: offset + 17)]
						ifFalse: ["type = 13, 14 or 15"
							^ client
								send: (method literalAt: offset + 1)
								super: false
								numArgs: type - 13]]].


"    old code 
	type=0 ifTrue: [^client pushReceiverVariable: offset].
	type=1 ifTrue: [^client pushTemporaryVariable: offset].
	type=2 ifTrue: [^client pushConstant: (method literalAt: offset+1)].
	type=3 ifTrue: [^client pushConstant: (method literalAt: offset+17)].
	type=4 ifTrue: [^client pushLiteralVariable: (method literalAt: offset+1)].
	type=5 ifTrue: [^client pushLiteralVariable: (method literalAt: offset+17)].
	type=6 
		ifTrue: [offset<8
					ifTrue: [^client popIntoReceiverVariable: offset]
					ifFalse: [^client popIntoTemporaryVariable: offset-8]].
	type=7
		ifTrue: [offset=0 ifTrue: [^client pushReceiver].
				offset<8 ifTrue: [^client pushConstant: (SpecialConstants at: offset)].
				offset=8 ifTrue: [^client methodReturnReceiver].
				offset<12 ifTrue: [^client methodReturnConstant: 
												(SpecialConstants at: offset-8)].
				offset=12 ifTrue: [^client methodReturnTop].
				offset=13 ifTrue: [^client blockReturnTop].
				offset>13 ifTrue: [^self error: 'unusedBytecode']].
	type=8 ifTrue: [^self interpretExtension: offset in: method for: client].
	type=9
		ifTrue:  short jumps
			[offset<8 ifTrue: [^client jump: offset+1].
			^client jump: offset-8+1 if: false].
	type=10 
		ifTrue:  long jumps
			[byte:= method at: pc.  pc:= pc+1.
			offset<8 ifTrue: [^client jump: offset-4*256 + byte].
			^client jump: (offset bitAnd: 3)*256 + byte if: offset<12].
	type=11 
		ifTrue: 
			[^client 
				send: (Smalltalk specialSelectorAt: offset+1) 
				super: false
				numArgs: (Smalltalk specialNargsAt: offset+1)].
	type=12 
		ifTrue: 
			[^client 
				send: (Smalltalk specialSelectorAt: offset+17) 
				super: false
				numArgs: (Smalltalk specialNargsAt: offset+17)].
	type>12
		ifTrue: 
			[^client send: (method literalAt: offset+1) 
					super: false
					numArgs: type-13]"! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 17:51'!
skipBackBeforeJump
	"Assuming that the receiver is positioned jast after a jump, skip back one or two bytes, depending on the size of the previous jump instruction."
	| strm short extraLong |
	extraLong := false.
	strm _ InstructionStream on: self method.
	(strm scanFor: [:byte |
		(((short _ byte between: 152 and: 159) or: [byte between: 168 and: 175]) 
			or: [extraLong := byte = 126 and: [#(129 130) includes: (strm method at: strm pc + 1)]])
				and: [strm pc = (short ifTrue: [pc-1] ifFalse: [extraLong ifTrue: [pc-4] ifFalse: [pc-2]])]]) 
					ifFalse: [self error: 'Where''s the jump??'].
	self jump: (short ifTrue: [-1] ifFalse: [extraLong ifTrue: [-4] ifFalse: [-2]]).
! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 17:53'!
willJump
	"unconditionally"

	| byte |
	byte _ self method at: pc.
	^ ((byte between: 144 and: 151) 
		or: [byte between: 160 and: 167]) 
			or: [byte = 126 and: [(self method at: pc + 1) = 128]]! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 17:54'!
willJumpIfFalse
	"Answer whether the next bytecode is a jump-if-false."

	| byte |
	byte _ self method at: pc.
	^((byte between: 152 and: 159) 
		or: [byte between: 172 and: 175]) 
			or: [byte = 126 and: [(self method at: pc + 1) = 130]]! !

!InstructionStream methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 17:56'!
willJumpIfTrue 
	"Answer whether the next bytecode is a jump-if-true."
 
	| byte |
	byte _ self method at: pc.
	^ (byte between: 168 and: 171)
		or: [byte = 126 and: [(self method at: pc + 1) = 129]]! !

!BlockNode methodsFor: '*squeakelib-compiler' stamp: 'rww 10/21/2007 11:06'!
sizeForValue: encoder
	nArgsNode _ encoder encodeLiteral: arguments size.
	remoteCopyNode _ encoder encodeSelector: #blockCopy:.
	size _ (self sizeForEvaluatedValue: encoder)
				+ (self returns ifTrue: [0] ifFalse: [1]). "endBlock"
	arguments _ arguments collect:  "Chance to prepare debugger remote temps"
				[:arg | arg asStorableNode: encoder].
	arguments do: [:arg | size _ size + (arg sizeForStorePop: encoder)].
	^1 + (nArgsNode sizeForValue: encoder) 
		+ (remoteCopyNode size: encoder args: 1 super: false) + (self sizeLongJump: size) + size! !

DecompilerConstructor subclass: #ConditionalTransformDecompilerConstructor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakElib-Compiler'!

!ConditionalTransformDecompilerConstructor methodsFor: 'constructor' stamp: 'rww 10/21/2007 16:16'!
codeMessage: receiver selector: selector arguments: arguments
	| symbol node |
	symbol _ selector key.
	(node _ BraceNode new
			matchBraceWithReceiver: receiver
			selector: symbol
			arguments: arguments) ifNotNil: [^ node].
	(node _ self decodeIfNilWithReceiver: receiver
			selector: symbol
			arguments: arguments) ifNotNil: [^ node].
	^ ConditionalTransformMessageNode new
			receiver: receiver selector: selector
			arguments: arguments
			precedence: symbol precedence! !

!ConditionalTransformDecompilerConstructor methodsFor: 'constructor' stamp: 'rww 10/21/2007 16:16'!
decodeIfNilWithReceiver: receiver selector: selector arguments: arguments

	selector == #ifTrue:ifFalse:
		ifFalse: [^ nil].
	(receiver isMessage: #==
				receiver: nil
				arguments: [:argNode | argNode == NodeNil])
		ifFalse: [^ nil].
	^ (ConditionalTransformMessageNode new
			receiver: receiver
			selector: (SelectorNode new key: #ifTrue:ifFalse: code: #macro)
			arguments: arguments
			precedence: 3)
		noteSpecialSelector: #ifNil:ifNotNil:! !
CompiledMethod initialize!
ConditionalTransformMessageNode initialize!
